<?php
class AttendanceItemconfController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host', 'Rlthstgrp','Grpauth', 'Authority','Rltuserauth','User','Configure','Validation',
	'Employee', 'Seatlayout', 'Siteinfo', 'Draftlayout', 'Draftinfo');
	var $layout='attendance';
	
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('title',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	
	//////////レイアウト編集
	function index($a=null)
	{
		$this->pageTitle =__('title',$return = true);
		
		$infoall = $this->Siteinfo->findAll();
//var_dump($infoall);
		$this->set('infoall', $infoall);
		$this->render('index');
	}
	
	function layout($site_id)
	{
		$this->layout="attendance";
		$this->set('siteid', $site_id);
		
		$info = $this->Siteinfo->findById($site_id);//var_dump($info);
		$this->set('sitename', $info['Siteinfo']['site_name']);
		
		$dlist = $this->getDrafts($site_id);
		$this->set('drafts', $dlist);
	}
	
	//アイテムの配置を取得
	function search($site_id=1)
	{
		$this->layout="ajax";
		
		$draft= json_decode($_POST['draft']);
		
		$asso = array(
			'Employee : employees : LEFT' => array('Employee.id = Seatlayout.emp_id')		
		) ;
		if($draft > 0){
			$asso['Draftlayout : draftlayouts : LEFT'] = array(
				'Seatlayout.id = Draftlayout.seat_id', 
				'Seatlayout.site_id = Draftlayout.site_id',
				"Draftlayout.draft_id = ".$draft
				);
		}

		//取得項目
		$fields = array(
			'Seatlayout.id as id',
			'Employee.id as eid',
			'Employee.id_name as idname',
			'Employee.name as ename',
			'Employee.name_eng as nameeng',
			'Employee.linenumber as line',
			'Seatlayout.name as iname',
			'Seatlayout.itemcolor as icolor',
			'Seatlayout.bordercolor as bcolor',
			'Seatlayout.size_x as size_x',
			'Seatlayout.size_y as size_y',
			'Seatlayout.linestyle as linestyle',
		);
		if($draft > 0){
			$fields[] = '(case when Draftlayout.pos_x is null then -1 else Draftlayout.pos_x end) as pos_x';
			$fields[] = '(case when Draftlayout.pos_y is null then -1 else Draftlayout.pos_y end) as pos_y';
		}else{
			$fields[] = 'Seatlayout.pos_x as pos_x';
			$fields[] = 'Seatlayout.pos_y as pos_y';
		}
		$criteria = array("1=1");
		$criteria[]="Seatlayout.site_id = ".$site_id;
		

		//取得
		$Seatlayout = $this->Seatlayout->findByAsso($criteria, $fields, null, null, null, $asso);
		//exit;
		header("Content-Type: application/json; charset=utf-8");
		$json = json_encode( $Seatlayout ) ;
		$this->set(compact('json'));
	}
	function save()
	{
		$this->layout="ajax";
		//echo $_POST['json'];
		//var_dump($_POST);
		$data = json_decode($_POST['json']);
		$draft= json_decode($_POST['draft']);
		$site= json_decode($_POST['site']);
		//var_dump($data);
		$del_cache = false;
		foreach($data as $d){
			//var_dump($d[0]);
			//echo $d[0]->id."/".$d[0]->pos_x."/".$d[0]->pos_y;
			if($draft > 0){
				$crit = array('Draftlayout.seat_id ='.$d[0]->id,
						'Draftlayout.draft_id ='.$draft);
				$exists = $this->Draftlayout->findAll($crit);
				if(empty($exists)){
				$set_update=Array(
					'Draftlayout' => Array(
						'seat_id' => $d[0]->id,
						'draft_id' => $draft,
						'site_id' => $site,
						'pos_x' => $d[0]->pos_x,
						'pos_y' => $d[0]->pos_y,
					)
				);
				$this->Draftlayout->save($set_update);
				}else{
					$this->Draftlayout->updateAll($crit, array('Draftlayout.pos_x' => $d[0]->pos_x,
							'Draftlayout.pos_y' => $d[0]->pos_y) );
				}
			}else{
				$set_update=Array(
					'Seatlayout' => Array(
						'id' => $d[0]->id,
						'pos_x' => $d[0]->pos_x,
						'pos_y' => $d[0]->pos_y,
					)
				);
				$this->Seatlayout->save($set_update);
				$del_cache = true;
			}
		}
		if($del_cache){
			//$cache_file = str_replace("\\","/", TMP)."views/";
		}
			
	}
	
	function getDrafts($siteid){
		$criteria=array("Draftinfo.site_id" => $siteid);
		$drafts = $this->Draftinfo->findAll($criteria,null,array("Draftinfo.id"));
		$keys = Set::extract($drafts, '{n}.Draftinfo.id');
		$vals = Set::extract($drafts, '{n}.Draftinfo.name');
		$dlist = array_combine($keys, $vals);
		return $dlist;
	}
	function newdraft(){
		$this->layout = 'ajax';
		//var_dump($_POST);
		$siteid = $this->Lv->spec_char_dbm($this->data['Draftinfo']['siteid']);
		$name = $this->data['Draftinfo']['name'];
		$user = $this->Session->read('user');
		$newdraft = array(
				'Draftinfo' => array(
						'site_id' => $siteid,
						'name' => $this->Lv->spec_char_dbm($name),
						'update_time' => "'".date("Y/m/d H:i:s")."'",
						'update_user' => "'".$user['user_name']."'",
						'regist_user' => "'".$user['user_name']."'"
					)
				); 			
		$this->Draftinfo->save($newdraft);
		$dlist = $this->getDrafts($siteid);
		$this->set('drafts', $dlist);
		//var_dump($dlist);
		$this->render("select");
	}
	function deldraft(){
		$this->layout = 'ajax';
		//var_dump($_POST);
		$siteid = $this->Lv->spec_char_dbm($this->data['Draftinfo']['siteid']);
		$draft_id = $this->Lv->spec_char_dbm($this->data['Draftlayout']['draft_id']);

		$this->Draftlayout->deleteAll(array("draft_id =". $draft_id));
		$this->Draftinfo->deleteAll(array("id =". $draft_id));
		
		$dlist = $this->getDrafts($siteid);
		$this->set('drafts', $dlist);
		$this->render("select");
	}
	
	/////////////////アイテム編集
	function items($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		
		$sites = $this->Siteinfo->findAll();
		$keys = Set::extract($sites, '{n}.Siteinfo.id');
		$vals = Set::extract($sites, '{n}.Siteinfo.site_name');
		$slist = array_combine($keys, $vals);
		$slist['']="";
		ksort($slist);
		$this->set('slist',$slist);
		
		$site_id = $this->Session->read('site_id');
		$this->set('site_id',$site_id);
		
		if(!empty($errorMessage))
			$this->set('errorMessage',$errorMessage);
	}
	
	function lists($mode=null)
	{
		$this->layout="ajax";
	
		$item_id = $this->data['Seatlayout']['id'];
		$site_id = $this->data['Siteinfo']['id'];
		$keyword = $this->data['keyword']['input'];

		///取得条件設定
		$asso = array(
			'Employee : employees : LEFT' => array('Employee.id = Seatlayout.emp_id'),
			'Siteinfo : siteinfo : LEFT' => array('Siteinfo.id = Seatlayout.site_id')		
		) ;
		
		//取得項目
		$fields = array(
			'Seatlayout.id',
			'Siteinfo.site_name',
			'Employee.id_name',
			'Employee.name',
			'Seatlayout.name',
			'Seatlayout.itemcolor',
			'Seatlayout.size_x',
			'Seatlayout.size_y'
		);
		
		$criteria = array("1=1");
		if(!empty($site_id) && is_numeric($site_id)){
			$criteria[]="Seatlayout.site_id = ".$site_id;
			$this->Session->write('site_id',$site_id);
		}else
			$this->Session->write('site_id',"");
		if(!empty($item_id) && is_numeric($item_id))
			$criteria[]="Seatlayout.id = ".$item_id;
		//キーワードを指定
		if($keyword != ""){
			$kw = $this->Lv->spec_char_like($keyword);
			$criteria[]="(Employee.id_name like '%".$kw."%' or Employee.name like '%".$kw."%' or Seatlayout.name like '%".$kw."%' )";
		}

		//取得
		$this->Pagination->show = 50;
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, 
						array('ajaxDivUpdate'=>'lists', 'url'=>'/attendance_itemconf/lists', 'modelClass'=>'Seatlayout', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy(
						'Seatlayout.id',
						'Siteinfo.site_name',
						'Employee.id_name',
						'Employee.name',
						'Seatlayout.name',
						'Seatlayout.itemcolor',
						'Seatlayout.size_x',
						'Seatlayout.size_y')));
		if($mode == "csv"){
			$fields[] = "Seatlayout.bordercolor";
			$fields[] = "Seatlayout.linestyle";
			$Seatlayout = $this->Seatlayout->findByAsso($criteria, $fields, $order, null, null, $asso);
			foreach($Seatlayout as &$record){

				if($record['Seatlayout']['linestyle'] == '1')
					$record['Seatlayout']['linestylestr'] = __('line_dash', $return = true);
				else if($record['Seatlayout']['linestyle'] == '2')
					$record['Seatlayout']['linestylestr'] = __('line_dot', $return = true);
				else if($record['Seatlayout']['linestyle'] == '3')
					$record['Seatlayout']['linestylestr'] = __('line_double', $return = true);
				else if($record['Seatlayout']['linestyle'] == '4')
					$record['Seatlayout']['linestylestr'] = __('line_thick', $return = true);
				else
					$record['Seatlayout']['linestylestr'] = __('line_normal', $return = true);
			}
			
			$this->csvdown($Seatlayout);exit();
			
		}else{
			$Seatlayout = $this->Seatlayout->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
			$this->set('data',$Seatlayout);
			//var_dump($Seatlayout);
			$this->render('lists');
		}
		
	}
	
	function csvdown($data = array())
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("attendance_items");
		
		$csv->sendCSVFile($data, $this->data, __('csv_name',$return = true));
		exit;
	}
	
	function update($eid = null)
	{
		//$this->layout='ajax';
		$criteria = array();
		
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		
		$sites = $this->Siteinfo->findAll();
		$keys = Set::extract($sites, '{n}.Siteinfo.id');
		$vals = Set::extract($sites, '{n}.Siteinfo.site_name');
		$slist = array_combine($keys, $vals);
		$this->set('slist',$slist);
		
		$site_id = $this->Session->read('site_id');
		$this->set('site_id',$site_id);
		
		$xylist = array();
		for($i = 1; $i < 11; $i++)
			$xylist[$i] = $i;
		$this->set('xylist',$xylist);
		
		$criteria = array();
		if(is_numeric($eid)){//編集
			$this->set('edit', true);
			//取得条件設定
			$asso = array(
				'Employee : employees : LEFT' => array('Employee.id = Seatlayout.emp_id'),
				'Siteinfo : siteinfo : LEFT' => array('Siteinfo.id = Seatlayout.site_id')	
			) ;
			
			//取得項目
			$fields = array(
				'Seatlayout.id',
				'Employee.id_name',
				'Employee.name',
				'Employee.id',
				'Siteinfo.id',
				'Siteinfo.site_name',
				'Seatlayout.name',
				'Seatlayout.itemcolor',
				'Seatlayout.bordercolor',
				'Seatlayout.linestyle',
				'Seatlayout.size_x',
				'Seatlayout.size_y',
			);
			
			$criteria[]="Seatlayout.id = ".$eid;
			$Seatlayout = $this->Seatlayout->findByAsso($criteria, $fields, null, null, null, $asso);
			//debug($Employee);
			
			$this->set('curtID', $Seatlayout[0]['Seatlayout']['id']);
			$this->set('curtEmpID', $Seatlayout[0]['Employee']['id']);
			$this->set('curtIDName', $Seatlayout[0]['Employee']['id_name']);
			$this->set('curtItemName', $Seatlayout[0]['Seatlayout']['name']);
			$this->set('curtSite', $Seatlayout[0]['Siteinfo']['id']);
			$this->set('curtBack', $Seatlayout[0]['Seatlayout']['bordercolor']);
			$this->set('curtFore', $Seatlayout[0]['Seatlayout']['itemcolor']);
			$this->set('curtLine', $Seatlayout[0]['Seatlayout']['linestyle']);
			$this->set('curtSizeX', $Seatlayout[0]['Seatlayout']['size_x']);
			$this->set('curtSizeY', $Seatlayout[0]['Seatlayout']['size_y']);
			
		}else{//追加
			$this->set('edit', false);
			
			$bcolor = "#040404";
			$fcolor = "#ffffff";
			$dir=DATABASE_PATH."\\..\\custom.ini";
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array)) {
				if (isset($ini_array['Item']['color'])) {
					$fcolor = $ini_array['Item']['color'];
				}
				if (isset($ini_array['Item']['bordercolor'])) {
					$bcolor = $ini_array['Item']['bordercolor'];
				}
			}

			$this->set('curtBack', $bcolor);
			$this->set('curtFore', $fcolor);
		}
		//$this->render('form');
	}
	
	
	function del(){
		$this->layout = 'ajax';
		//	debug($this->data['Employee']['delid']);
		if(isset($this->data['Employee']['delid'])){
			$eids  = $this->data['Employee']['delid'];
			foreach ($eids as $i => $check){
				$this->Seatlayout->deleteAll(array("id =". $check));
			}
		}
		$this->lists();
	}

	function add()
	{//debug($this->data);
		$this->layout = 'ajax';//exit();
		$errorMessage = array();
		
		$id = $this->data['Seatlayout']['id'];
		$site_id = $this->data['Siteinfo']['id'];
		if(empty($id))//新規の場合
			$this->Session->write('site_id',$site_id);
		$emp_id = $this->data['Employee']['id'];
		$item_name = $this->Lv->spec_char_dbm($this->data['Seatlayout']['name']);
		
		$itemcolor = $this->Lv->spec_char_dbm($this->data['Seatlayout']['itemcolor']);
		$bordercolor = $this->Lv->spec_char_dbm($this->data['Seatlayout']['bordercolor']);
		$size_y = $this->Lv->spec_char_dbm($this->data['Seatlayout']['size_y']);
		$size_x = $this->Lv->spec_char_dbm($this->data['Seatlayout']['size_x']);
		$linestyle = $this->data['Seatlayout']['linestyle'];

		$errorMessage = $this->addEmployee($id, $site_id, $emp_id, $item_name, $itemcolor, $bordercolor, $size_x, $size_y, $linestyle);

		$this->set('errorMessage', $errorMessage);
	}
	function addEmployee($id, $site_id, $emp_id, $item_name, $itemcolor, $bordercolor, $size_x, $size_y, $linestyle)
	{
		$edit = false;
		$errorMessage = array();
		
		if(empty($site_id)){
			$errorMessage['site_name'][] = 'E-00100';
		}
		
		if(empty($emp_id)){//プリンタなど
			if(empty($item_name)){
				$errorMessage['item_name'][] = 'E-00100';
			}
			if(empty($itemcolor)){
				$errorMessage['itemcolor'][] = 'E-00100';
			}
			if(empty($bordercolor)){
				$errorMessage['bordercolor'][] = 'E-00100';
			}
		}else if(empty($id)){//新規従業員アイテムの時重複確認
			$criteria = array();
			$criteria[] = "Seatlayout.emp_id = '".$this->Lv->spec_char_dbm($emp_id)."'";
			$criteria[] = "Seatlayout.site_id = '".$this->Lv->spec_char_dbm($site_id)."'";
			$acc = $this->Seatlayout->find($criteria);
			if(!empty($acc)){
				$errorMessage['employee_id'][] = 'E-01900';
			}
		}

		if(empty($errorMessage)){
			$user = $this->Session->read('user');
			$newlayout = array(
				'Seatlayout' => array(
						'site_id' => $site_id,
						'emp_id' => $emp_id,
						'name' => $item_name,
						'size_x' => $size_x,
						'size_y' => $size_y,
						'itemcolor' => $itemcolor,
						'bordercolor' => $bordercolor,
						'linestyle' => $linestyle,
						'update_time' => "'".date("Y/m/d H:i:s")."'",
						'update_user' => "'".$user['user_name']."'"
					)
				); 			
			if(!empty($id)){//編集の場合
				$edit = true;
				$newlayout['Seatlayout']['id'] = $id;
			}else{
				$newlayout['Seatlayout']['id'] = null;
				$newlayout['Seatlayout']['regist_user'] = "'".$user['user_name']."'";
			}
			$this->Seatlayout->save($newlayout);
			
		}
		return $errorMessage;
	}
	
	function do_import()
  	{
  		require_once("csv_imports_controller.php");
  		$hear_num = 1;
		//$dataにCSVからの情報が入る
		$data = CsvImportsController :: do_import($hear_num);
		//debug($data);
		
		$errorMessage = array();
		if($data[0]!='error_csv' && $data[0]!='error_format'){
			empty($errorMessage)?$errorMessage=null:$errorMessage=$errorMessage;
		}else{
			$errorMessage[__('surecsv',$return = true)][] = 'E-06000';
		}
		
		if(empty($errorMessage)){
			$domains = array();
			$orgdomains = array();
			$linenum = 1;
			foreach($data as $v)
			{
				$linenum++;
				if (is_array($v)) 
				{
					$err = array();
					//アイテムID(既にあれば変更)
					$id = null;
					$tmp_id = $this->Lv->spec_char_dbm($v[0]);
					if(!empty($tmp_id)){
						$s = array();
						$s = $this->Seatlayout->findById($tmp_id);
						if(!empty($s))
							$id = $s['Seatlayout']['id'];
					}
					//サイト
					$site = array();
					$site = $this->Siteinfo->findBySiteName($this->Lv->spec_char_dbm($v[1]));
					if(empty($site))
						$err[$v[1]][] = 'UPE-00400';//存在しない
					$site_id = $site['Siteinfo']['id'];
					//従業員
					$emp_id = null;
					if(!empty($v[2])){
						$emp = array();
						$emp = $this->Employee->findByIdName($this->Lv->spec_char_dbm($v[2]));
						if(empty($emp))
							$err[$v[2]][] = 'UPE-00450';//存在しない
						$emp_id = $emp['Employee']['id'];
					}
					if(!empty($v[3])){
						/*$emp = array();
						$emp = $this->Employee->findByName($this->Lv->spec_char_dbm($v[3]));
						if(empty($emp))
							$err[$v[3]][] = 'UPE-00450';//存在しない
						$emp_id2 = $emp['Employee']['id'];
						if($emp_id != $emp_id2){
							$err[$v[2]."/".$v[3]][] = 'UPE-00460';//not match
						}*/
					}
					//item名
					$item_name = $v[4];
					//color
					if(is_null($emp_id)){
						$itemcolor = $v[5];
						if(!$this->Validation->custom($itemcolor, '/^#[A-F0-9]{6}$/i')){
							$err['itemcolor'][] = 'UPE-00600';//#112233
						}
					}
					//size
					$size_y = $v[6];
					if(!(0 < $size_y && $size_y < 11))
						$err[$v[6]][] = 'UPE-00700';
					$size_x = $v[7];
					if(!(0 < $size_x && $size_x < 11))
						$err[$v[7]][] = 'UPE-00700';
					//枠線color
					$bordercolor = $v[8];	
					if(!$this->Validation->custom($bordercolor, '/^#[A-F0-9]{6}$/i')){
						$err['bordercolor'][] = 'UPE-00600';//#112233
					}					
					//枠線
					$linestyle = 0;
					if(!empty($v[9])) {
						if($v[9] == __('line_normal', true))
							$linestyle = 0;
						else if($v[9] == __('line_dash', true))
							$linestyle = 1;
						else if($v[9] == __('line_dot', true))
							$linestyle = 2;
						else if($v[9] == __('line_double', true))
							$linestyle = 3;
						else if($v[9] == __('line_thick', true))
							$linestyle = 4;
					}else
						$linestyle = 0;

					if(empty($err)){//エラーがある行は入れない
						$msg = $this->addEmployee($id, $site_id, $emp_id, $item_name, $itemcolor, $bordercolor, $size_x, $size_y, $linestyle);
						if(!empty($msg))
							$errorMessage[$linenum] = $msg;
					}else
						$errorMessage[$linenum] = $err;
				}
			}

		}
		
		$this->items($errorMessage,null);
		$this->layout='attendance';
		$this->render("items");
  	}
	
	function employsearch()
	{
		$this->layout = 'ajax';
		$id_name = $this->data['Search']['id_name'];
		$name = $this->data['Search']['name'];
		$group_id = $this->data['Search']['group'];
		
		
		$crit = array("1=1");
		if(!empty($id_name))
			$crit[] = "Employee.id_name like '%".$this->Lv->spec_char_like($id_name)."%'";
		if(!empty($name))
			$crit[] = "Employee.name like '%".$this->Lv->spec_char_like($name)."%'";
		//if(!empty($group))
		//	$crit[] = "Employee.group_id = ".$group;
		if($group_id != 1 && isset($group_id)){
			$group_ids = "";
			$glist = $this->Grpauth->getChildrenByParent($group_id);
			foreach($glist as $key => $g){
				$group_ids .= $key.",";
			}
			$group_ids = rtrim($group_ids, ","); 
			$crit[]="Employee.group_id in (".$group_ids.")";
		}
		$search = $this->Employee->findAll($crit);
		$this->set('search', $search);
	}
	
}
?>